
/* BEGIN COPYRIGHT NOTICE

Copyright (c) 1992 by John Sarraille and Peter DiFalco
(john@ishi.csustan.edu)

Copyright (c) 1998 by John Sarraille
(john@ishi.csustan.edu)

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that copyright notice and this permission
notice appear in supporting documentation.

The algorithm used in this program was inspired by the paper
entitled "A Fast Algorithm To Determine Fractal Dimensions By
Box Counting", which was written by Liebovitch and Toth, and
which appeared in the journal "Physics Letters A", volume 141,
pp 386-390, (1989).

This program is not warranted: use at your own risk.

END COPYRIGHT NOTICE */

/*

        HEADER FILE FOR FD3 SOFTWARE

        Filename:  covmacro.h

        THIS FILE CONTAINS MACRO VERSIONS OF FUNCTIONS IN THE
        FILE covers.c.  SEE THE DOCUMENTATION IN THAT FILE FOR
        INFORMATION ABOUT WHAT THESE MACROS DO.

*/

/* 
    THE MACROS IN THIS FILE: 
*/

/*

SEEKbitCHANGE
     CHECKbit
UPDATEcovSTATS

*/

/* ######################################################### */
/*                           CHECKbit                        */
/* ######################################################### */
#define CHECKbit(cDp)                                         \
((cDp)->coord) = ((cDp)->embedDim) ;                          \
while ( (((cDp)->coord) > 0) && (! ((cDp)->bitChFnd) ) )      \
{ ((cDp)->coord)-- ;                                          \
  ((cDp)->bitChFnd) =                                         \
  ISa(((uLong) 1),((cDp)->ptDiff)[((cDp)->coord)],((cDp)->bitPos));}
/* ######################################################### */
/*                        SEEKbitCHANGE                      */
/* ######################################################### */
#define  SEEKbitCHANGE(pIdx, cIdx, rDp, cDp)                  \
   for (((cDp)->coord) = 0;                                   \
       ((cDp)->coord) < ((rDp)->embedDim);                    \
       ((cDp)->coord)++)                                      \
       ((cDp)->ptDiff)[((cDp)->coord)] =                      \
                 ((rDp)->pointList)[((cDp)->coord)][(pIdx)]   \
               ^ ((rDp)->pointList)[((cDp)->coord)][(cIdx)] ; \
   ((cDp)->bitPos)  =  ((rDp)->ulongBitNum) ;                 \
   ((cDp)->bitChFnd)   =  FALSE ;                             \
   while ( (!((cDp)->bitChFnd)) && (((cDp)->bitPos) > 0) )    \
   {  ((cDp)->bitPos)-- ;                                     \
      {CHECKbit(cDp);}  }                                     \
   ((cDp)->MSBdiff) = (int) ((cDp)->bitPos) ;
/* ######################################################### */
/*                      UPDATEcovSTATS                       */
/* ######################################################### */
#define UPDATEcovSTATS(rDp, cDp)                               \
   for (((cDp)->bitPos)=0;                                     \
        ((cDp)->bitPos)<=((cDp)->MSBdiff);                     \
        ((cDp)->bitPos)++)                                     \
   { (((cDp)->cellCount)[((cDp)->bitPos)])++ ;                 \
     ((cDp)->sProb) =   ((cDp)->pointCount)[((cDp)->bitPos)]   \
                      / (double)((rDp)->dataLines);            \
     ((cDp)->sumSqrFreq)[((cDp)->bitPos)]                      \
             +=   (((cDp)->sProb) * ((cDp)->sProb)) ;          \
     ((cDp)->information)[((cDp)->bitPos)]                     \
             +=   (((cDp)->sProb) * log(((cDp)->sProb))        \
                                  / ((cDp)->log2) ) ;          \
     ((cDp)->pointCount)[((cDp)->bitPos)] = 1 ;}               \
   for (   ((cDp)->bitPos)=((cDp)->MSBdiff)+1;                 \
           ((cDp)->bitPos)<((cDp)->numCellSizes);              \
           ((cDp)->bitPos)++)                                  \
       ( ((cDp)->pointCount)[((cDp)->bitPos)] )++ ;
/* ######################################################### */
/* ######################################################### */
/* ######################################################### */     
/*                      end covmacro.h                       */
/* ######################################################### */
/* ######################################################### */
/* ######################################################### */
