
/* BEGIN COPYRIGHT NOTICE

Copyright (c) 1992 by John Sarraille and Peter DiFalco
(john@ishi.csustan.edu)

Copyright (c) 1998 by John Sarraille
(john@ishi.csustan.edu)

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that copyright notice and this permission
notice appear in supporting documentation.

The algorithm used in this program was inspired by the paper
entitled "A Fast Algorithm To Determine Fractal Dimensions By
Box Counting", which was written by Liebovitch and Toth, and
which appeared in the journal "Physics Letters A", volume 141,
pp 386-390, (1989).

This program is not warranted: use at your own risk.

END COPYRIGHT NOTICE */

  /*

         FD3 PROGRAM FILE

        Filename:  sort.h

        THIS FILE CONTAINS MACRO VERSIONS OF SORTING FUNCTIONS
        IN THE FILE datarep.c.  SEE THE DOCUMENTATION IN THAT
        FILE FOR INFORMATION ABOUT WHAT THESE MACROS DO.

  */


      /* THE MACROS IN THIS FILE: */

  /*

       REqSRcRUN
       REqGENcASE
       rADpASS

  */

/* ######################################################### */
/*                           rADpASS                         */
/* ######################################################### */
#define rADpASS(rDptr, coord, bitpos)                                     \
{  int sQnum ;                                                            \
   uLong iSize[2], rmnder ;                                               \
   for (sQnum = 0; sQnum < 2; sQnum++ )                                   \
       iSize[sQnum]= SizeQ (&((rDptr)->Q[sQnum])) ;                       \
   for (sQnum = 0; sQnum < 2; sQnum++)                                    \
   { if (iSize[sQnum] != 0)                                               \
     { {REqSRcRUN(rDptr,coord,bitpos,(uLong)sQnum,iSize[sQnum],&rmnder);} \
       if (rmnder > 0)                                                    \
         {REqGENcASE(rDptr,coord,bitpos,(uLong)sQnum, rmnder)}; }}}       

/* ######################################################### */
/*                       REqSRcRUN                           */
/* ######################################################### */
#define REqSRcRUN(rDptr, coord, bitpos, sQnum, reQable, remgPtr)          \
{   uLong eltIdx ;                                                        \
    {DEQ(&(((rDptr)->Q)[(sQnum)]), ((rDptr)->nextAfter), &eltIdx);}       \
    (reQable)-- ;                                                         \
    while(((reQable) > 0) &&                                              \
          ISa((sQnum),((rDptr)->pointList)[(coord)][eltIdx],(bitpos)))    \
    { {ENQfAST(&(((rDptr)->Q)[(sQnum)]), ((rDptr)->nextAfter), eltIdx);}  \
      {DEQ(&(((rDptr)->Q)[(sQnum)]), ((rDptr)->nextAfter), &eltIdx);}     \
      (reQable)-- ;    }                                                  \
    if ISa((uLong) 0,((rDptr)->pointList)[(coord)][eltIdx],(bitpos))      \
          {ENQ(&(((rDptr)->Q)[0]),((rDptr)->nextAfter),eltIdx);}          \
    else  {ENQ(&(((rDptr)->Q)[1]),((rDptr)->nextAfter),eltIdx);}          \
    *(remgPtr) = (reQable) ; }

/* ######################################################### */
/*                       REqGENcASE                          */
/* ######################################################### */
#define REqGENcASE(rDptr, coord, bitpos, srcQnum, reQable)                 \
{  uLong eltNum, eltIdx ;                                                  \
   for (eltNum = 0; eltNum < (reQable) - 1; eltNum++)                      \
   { {DEQfAST(&(((rDptr)->Q)[(srcQnum)]), ((rDptr)->nextAfter), &eltIdx);} \
     if ISa((uLong) 0,((rDptr)->pointList)[(coord)][eltIdx],(bitpos))      \
           {ENQfAST(&(((rDptr)->Q)[0]),((rDptr)->nextAfter),eltIdx);}      \
     else  {ENQfAST(&(((rDptr)->Q)[1]),((rDptr)->nextAfter),eltIdx);}}     \
   {DEQ(&(((rDptr)->Q)[(srcQnum)]), ((rDptr)->nextAfter), &eltIdx);}       \
   if ISa((uLong) 0,((rDptr)->pointList)[(coord)][eltIdx],(bitpos))        \
         {ENQ(&(((rDptr)->Q)[0]),((rDptr)->nextAfter),eltIdx);}            \
   else  {ENQ(&(((rDptr)->Q)[1]),((rDptr)->nextAfter),eltIdx);}}           

/* ######################################################### */

/* ######################################################### */
/* ######################################################### */
/* ######################################################### */     
/*                        end sort.h                         */
/* ######################################################### */
/* ######################################################### */
/* ######################################################### */
